unit Package_1Unit;

interface

uses
  System.ComponentModel,
  System.Collections,
  Borland.Eco.Services,
  Borland.Eco.ObjectRepresentation,
  Borland.Eco.ObjectImplementation,
  Borland.Eco.UmlRt,
  Borland.Eco.UmlCodeAttributes;

type
  c_invoice = class;
  [UmlElement('Package', Id='E340AB5B-BEE4-47FE-ACE2-7638F1F6153A')]
  [EcoCodeGenVersion('2.0')]
  [UmlMetaAttribute('ownedElement', TypeOf(c_invoice))]
  Package_1 = class
  end;

  [assembly: RuntimeRequired(TypeOf(Package_1))]
  Ic_invoiceList = interface;

  [UmlCollection(TypeOf(c_invoice))]
  Ic_invoiceList = interface(ICollection)
    {$REGION 'ECO generated code'}
    function get_Item(index: Integer): c_invoice;
    procedure set_Item(index: Integer; Value: c_invoice);
    property Item[index: Integer]: c_invoice read get_Item write set_Item; default;
    function Add(value: c_invoice): Integer;
    function Contains(value: c_invoice): Boolean;
    function IndexOf(value: c_invoice): Integer;
    procedure Insert(index: Integer; value: c_invoice);
    procedure Remove(value: c_invoice);
    procedure Clear;
    procedure RemoveAt(index: Integer);
    {$ENDREGION 'ECO generated code'}
  end;

  [UmlElement(Id='c360f711-367f-48ef-9dcd-3ff5f9814dfb')]
  c_invoice = class(System.Object, ILoopBack)
    {$REGION 'ECO generated code'}
  public
  type
    Eco_LoopbackIndices = class
    public
    const
      Eco_FirstMember = 0;
    const
      Eco_MemberCount = (Eco_FirstMember + 2);
    const
      m_customer = Eco_FirstMember;
    const
      m_invoice_number = (Eco_LoopbackIndices.m_customer + 1);
    end;

    c_invoiceListAdapter = class(ObjectListAdapter, Ic_invoiceList)
    public
      constructor Create(source: IList);
      function get_Item(index: Integer): c_invoice;
      procedure set_Item(index: Integer; Value: c_invoice);
      property Item[index: Integer]: c_invoice read get_Item write set_Item; default;
      function Add(value: c_invoice): Integer;
      function Contains(value: c_invoice): Boolean;
      function IndexOf(value: c_invoice): Integer;
      procedure Insert(index: Integer; value: c_invoice);
      procedure Remove(value: c_invoice);
    end;

  strict protected
    eco_Content: IContent;
  strict private
    function IObjectProvider.AsIObject = IObjectProvider_AsIObject;
    function IObjectProvider_AsIObject: IObject;
  public
    function AsIObject: IObjectInstance;
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    function get_m_customer: string;
    procedure set_m_customer(Value: string);
    [UmlElement(Id='1ab8ec72-3c51-44f8-9e45-4a1c139cb448', Index=Eco_LoopbackIndices.m_customer)]
    property m_customer: string read get_m_customer write set_m_customer;
    function get_m_invoice_number: Integer;
    procedure set_m_invoice_number(Value: Integer);
    [UmlElement(Id='6b95d7a9-7232-474b-b244-c87521776797', Index=Eco_LoopbackIndices.m_invoice_number)]
    property m_invoice_number: Integer read get_m_invoice_number write set_m_invoice_number;
    [UmlElement(Id='d13f1ba4-8c13-49a2-8ac5-8ab828c21471')]
    function ToString: String; Override;
  strict protected
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    /// <summary>For Framework Internal use only</summary>
  public
    constructor Create(content: IContent); overload;
    {$ENDREGION 'ECO generated code'}
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;

implementation

function c_invoice.IObjectProvider_AsIObject: IObject;
begin
  Result := Self.eco_Content.AsIObject;
end;

function c_invoice.AsIObject: IObjectInstance;
begin
  Result := Self.eco_Content.AsIObject;
end;

procedure c_invoice.set_MemberByIndex(index: Integer; value: System.Object);
begin
  raise System.IndexOutOfRangeException.Create;
end;

function c_invoice.get_MemberByIndex(index: Integer): System.Object;
begin
  raise System.IndexOutOfRangeException.Create;
end;

procedure c_invoice.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self.eco_Content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self.eco_Content, Self);
    Self.eco_Content := nil;
  end;
end;

procedure c_invoice.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self.eco_Content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self.eco_Content := factory.CreateContent(Self);
    Self.eco_Content.LoopbackValid;
  end;
end;

/// <summary>For Framework Internal use only</summary>
constructor c_invoice.Create(content: IContent);
begin
  inherited Create;
  Self.eco_Content := content;
  content.AssertLoopbackUnassigned;
end;

{$ENDREGION 'ECO generated code'}

constructor c_invoice.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // User code here
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

    function c_invoice.ToString: String;
      begin
        Result:= m_customer+ m_invoice_number.ToString;
      end; // ToString

function c_invoice.get_m_invoice_number: Integer;
begin
  Result := (Integer(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.m_invoice_number)));
end;

procedure c_invoice.set_m_invoice_number(Value: Integer);
begin
  Self.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.m_invoice_number, (System.Object(Value)));
end;

function c_invoice.get_m_customer: string;
begin
  Result := (string(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.m_customer)));
end;

procedure c_invoice.set_m_customer(Value: string);
begin
  Self.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.m_customer, (System.Object(Value)));
end;

constructor c_invoice.c_invoiceListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function c_invoice.c_invoiceListAdapter.get_Item(index: Integer): c_invoice;
begin
  Result := (c_invoice(inherited Adaptee[index]));
end;

procedure c_invoice.c_invoiceListAdapter.set_Item(index: Integer; Value: c_invoice);
begin
  inherited Adaptee[index] := value;
end;

function c_invoice.c_invoiceListAdapter.Add(value: c_invoice): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function c_invoice.c_invoiceListAdapter.Contains(value: c_invoice): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function c_invoice.c_invoiceListAdapter.IndexOf(value: c_invoice): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure c_invoice.c_invoiceListAdapter.Insert(index: Integer; value: c_invoice);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure c_invoice.c_invoiceListAdapter.Remove(value: c_invoice);
begin
  Self.Adaptee.Remove(value);
end;

end.
